<template>
    <a v-if="header.type==='link'" :href="url">
        {{value}}
    </a>
    <data-grid-cell-toggle v-else-if="header.type==='toggle'"
                           :item="item"
                           :prop="header.value"
                           :url="header.url"
                           :id="id"
                           :except="header.except"
    ></data-grid-cell-toggle>
    <data-grid-cell-boolean v-else-if="header.type==='boolean'" :value="value"></data-grid-cell-boolean>
    <data-grid-cell-image v-else-if="header.type==='image'" :value="value" :header="header"></data-grid-cell-image>
    <div v-else v-html="value"></div>
</template>

<script>
    export default {
        props: {
            header: {
                type: Object,
                default: {}
            },
            item: {
                type: Object,
                default: {}
            },
            idKey: {
                type: String,
                default: 'id'
            }
        },

        computed: {
            url() {
                let url = this.header.url;

                if (url) {
                    return url.replace(/\{([a-z]+)\}/g, (m, p1) => {
                       return encodeURIComponent(this.item[p1]);
                    });
                }

                return this.value;
            },

            value() {
                return this.item[this.header.value];
            },

            id() {
                return this.item[this.idKey]
            }
        }
    }
</script>

<style scoped>

</style>
